/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.gui.widgets;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import org.visnow.vn.gui.swingwrappers.UserActionListener;
import org.visnow.vn.gui.swingwrappers.UserEvent;

/**
 *
 * @author know
 */


public class SectionPanel extends javax.swing.JPanel
{
    private Component content;
    private final Dimension expandedSize;
    /**
     * Creates new form SectionPanel
     */
    public SectionPanel()
    {
        initComponents();
        expandedSize = this.getPreferredSize();
        header.addUserActionListener(new UserActionListener()
        {
            @Override
            public void userChangeAction(UserEvent event)
            {
                if (header.isExpanded())
                    setPreferredSize(expandedSize);
                else
                    setPreferredSize(header.getPreferredSize());
                contentPanel.setVisible(header.isExpanded());
                if (getParent() != null)
                    getParent().repaint();
            }

            @Override
            public void userAction(UserEvent event)
            {
                if (header.isExpanded())
                    setPreferredSize(expandedSize);
                else
                    setPreferredSize(header.getPreferredSize());
                contentPanel.setVisible(header.isExpanded());
                if (getParent() != null)
                    getParent().repaint();
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The
     * content of this method is always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        header = new org.visnow.vn.gui.widgets.SectionHeader();
        contentPanel = new javax.swing.JPanel();

        setLayout(new java.awt.BorderLayout());
        add(header, java.awt.BorderLayout.NORTH);

        contentPanel.setLayout(new java.awt.BorderLayout());
        add(contentPanel, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    public void setTitle(String title)
    {
        header.setText(title);
    }
    
    @Override
    public Component add(Component content)
    {
        contentPanel.removeAll();
        contentPanel.add(content, BorderLayout.CENTER);
        this.content = content;
        return content;
    }
    
    public void setExpanded(boolean expanded)
    {
        header.setExpanded(expanded);
        contentPanel.setVisible(expanded);
    }

    @Override
    public void setFont(Font font)
    {
        if (header != null)
            header.setFont(font);
    }

    public void setHeaderForeground(Color fg)
    {
        if (header != null)
            header.setForeground(fg);
    }

    public void setText(String text)
    {
        if (header != null)
            header.setText(text);
    }

    public String getText()
    {
        return header.getText();
    }

    public boolean isShowIcon()
    {
        return header.isShowIcon();
    }

    public void setShowIcon(boolean showIcon)
    {
        header.setShowIcon(showIcon);
    }

    public boolean isShowCheckBox()
    {
        return header.isShowCheckBox();
    }

    public void setShowCheckBox(boolean showCheckBox)
    {
        header.setShowCheckBox(showCheckBox);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel contentPanel;
    private org.visnow.vn.gui.widgets.SectionHeader header;
    // End of variables declaration//GEN-END:variables
}
